<?php
namespace plugins\file_manager\services;

use plugins\file_manager\library\exceptions;

class WriteFile {

    private $filename;
    private $content;

    public function __construct( $filename, $content ) {
        $this->filename = $filename;
        $this->content = $content;
    }

    public function perform( $listener ) {
        if ( !is_file( $this->filename ) ) {
            throw new exceptions\FileNotFoundException( sprintf( 'The file %s does not exist.', $this->filename ) );
        }
        if ( !is_writable( $this->filename ) ) {
            throw new exceptions\FileNotWritableException( sprintf( 'The file %s is not writable.', $this->filename ) );
        }
        if ( false !== file_put_contents( $this->filename, $this->content ) ) {
            return $this->filename;
        } else {
            throw new \RuntimeException( sprintf( 'Unable to write file %s.', $this->filename) );
        }
    }
}
